(function () {
    'use strict';

    function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator['throw'](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    }
    function __generator(thisArg, body) {
      var _ = {
          label: 0,
          sent: function () {
            if (t[0] & 1)
              throw t[1];
            return t[1];
          },
          trys: [],
          ops: []
        }, f, y, t, g;
      return g = {
        next: verb(0),
        'throw': verb(1),
        'return': verb(2)
      }, typeof Symbol === 'function' && (g[Symbol.iterator] = function () {
        return this;
      }), g;
      function verb(n) {
        return function (v) {
          return step([
            n,
            v
          ]);
        };
      }
      function step(op) {
        if (f)
          throw new TypeError('Generator is already executing.');
        while (g && (g = 0, op[0] && (_ = 0)), _)
          try {
            if (f = 1, y && (t = op[0] & 2 ? y['return'] : op[0] ? y['throw'] || ((t = y['return']) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
              return t;
            if (y = 0, t)
              op = [
                op[0] & 2,
                t.value
              ];
            switch (op[0]) {
            case 0:
            case 1:
              t = op;
              break;
            case 4:
              _.label++;
              return {
                value: op[1],
                done: false
              };
            case 5:
              _.label++;
              y = op[1];
              op = [0];
              continue;
            case 7:
              op = _.ops.pop();
              _.trys.pop();
              continue;
            default:
              if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                _ = 0;
                continue;
              }
              if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                _.label = op[1];
                break;
              }
              if (op[0] === 6 && _.label < t[1]) {
                _.label = t[1];
                t = op;
                break;
              }
              if (t && _.label < t[2]) {
                _.label = t[2];
                _.ops.push(op);
                break;
              }
              if (t[2])
                _.ops.pop();
              _.trys.pop();
              continue;
            }
            op = body.call(thisArg, _);
          } catch (e) {
            op = [
              6,
              e
            ];
            y = 0;
          } finally {
            f = t = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return {
          value: op[0] ? op[1] : void 0,
          done: true
        };
      }
    }
    function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    }

    var loadExternalScript = function (tagId, src, parentEl, scriptOperation) {
      if (parentEl === void 0) {
        parentEl = document.head;
      }
      if (!parentEl.querySelector('#' + tagId)) {
        return dynamicLoadResource(function () {
          var script = document.createElement('script');
          script.id = tagId;
          script.src = src;
          script.async = true;
          if (scriptOperation) {
            scriptOperation(script);
          }
          return script;
        }, parentEl);
      } else {
        return Promise.resolve(true);
      }
    };
    var dynamicLoadResource = function (creation, parentEl) {
      if (parentEl === void 0) {
        parentEl = document.head;
      }
      return new Promise(function (resolve, reject) {
        var el = creation();
        if (el === null) {
          resolve(false);
          return;
        }
        el.onload = function () {
          resolve(true);
        };
        el.onerror = function () {
          reject(false);
        };
        parentEl.appendChild(el);
      });
    };
    var htmlEncode = function (html) {
      var div = document.createElement('div');
      div.textContent = html;
      return div.innerHTML;
    };
    var isPreElement = function (el) {
      return !!el && el.nodeName.toLowerCase() === 'pre';
    };
    var isDetailsElement = function (el) {
      return !!el && el.nodeName.toLowerCase() === 'details';
    };
    var isSpanElement = function (el) {
      return !!el && el.nodeName.toLowerCase() === 'span';
    };
    var isDivElement = function (el) {
      return !!el && el.nodeName.toLowerCase() === 'div';
    };
    var contentEditableAttributeName = 'contenteditable';
    var hasUnEditableAttribute = function (el) {
      var _a;
      return !!el && ['false'].includes((_a = el.getAttribute(contentEditableAttributeName)) !== null && _a !== void 0 ? _a : '');
    };
    var hasNoUnEditableAttribute = function (el) {
      return !hasUnEditableAttribute(el);
    };
    var markContentUnEditable = function (el) {
      if (el) {
        el.setAttribute(contentEditableAttributeName, 'false');
      }
    };
    var removeContentEditableAttribute = function (el) {
      if (el) {
        el.removeAttribute(contentEditableAttributeName);
      }
    };
    var addSelectedAttribute = function (el) {
      if (el) {
        el.setAttribute('data-mce-selected', '1');
      }
    };

    var ContentBuilder = function () {
      function ContentBuilder(editor, settings) {
        this.editor = editor;
        this.settings = settings;
      }
      Object.defineProperty(ContentBuilder, 'iframe', {
        get: function () {
          return document.querySelector('.tox-navobj iframe');
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(ContentBuilder, 'cmEditor', {
        get: function () {
          var _a, _b, _c;
          return (_c = ((_b = (_a = this.iframe) === null || _a === void 0 ? void 0 : _a.contentWindow) !== null && _b !== void 0 ? _b : {})['cmEditor']) !== null && _c !== void 0 ? _c : null;
        },
        enumerable: false,
        configurable: true
      });
      ContentBuilder.prototype.build = function () {
        return '\n    <!DOCTYPE html>\n    <html lang="zh">\n      <head>\n        '.concat(this.buildHead(), '\n      <title></title>\n      </head>\n      <body>\n      </body>\n    </html>\n    ');
      };
      ContentBuilder.prototype.buildHead = function () {
        return '\n    <base href="'.concat(this.editor.dom.encode(this.editor.documentBaseURI.getURI()), '">\n    <link type="text/css" rel="stylesheet" href="').concat(this.settings.codeMirrorBasePath, '/codemirror.min.css">\n    <script type="text/javascript" src="').concat(this.settings.codeMirrorBasePath, '/codemirror.min.js"></script>\n    <script type="text/javascript" src="').concat(this.settings.codeMirrorBasePath, '/addon/display/placeholder.js"></script>\n    ').concat(ContentBuilder.buildCodeMirrorInitializeScript(), '\n    ').concat(ContentBuilder.buildStyle());
      };
      ContentBuilder.buildCodeMirrorInitializeScript = function () {
        return '\n    <script type="text/javascript">\n      window.onload = function() {\n        window.cmEditor = CodeMirror(document.body, {\n          value: "",\n          lineNumbers: true,\n          indentUnit: 4,\n          placeholder: "\u5728\u6b64\u8f93\u5165\u4ee3\u7801",\n          indentWithTabs: false,\n          extraKeys: {\n            Tab: function (cm) {\n              if (cm.somethingSelected()) {\n                cm.indentSelection("add");\n              } else {\n                cm.replaceSelection(cm.getOption("indentWithTabs")? "\\t":\n                  Array(cm.getOption("indentUnit") + 1).join(" "), "end", "+input");\n              }\n            }\n          }\n        });\n      }\n    </script>\n    ';
      };
      ContentBuilder.buildStyle = function () {
        return '\n    <style>\n      * {\n        box-sizing: border-box;\n      }\n      html,\n      body,\n      .CodeMirror {\n        height: 100%;\n        line-height: 1.5;\n        font-size: 16px;\n        font-family: monospace, -apple-system,BlinkMacSystemFont,\'Segoe UI\',Roboto,Oxygen,Ubuntu,Cantarell,\'Open Sans\',\'Helvetica Neue\',sans-serif;\n      }\n      body {\n        margin: 0;\n      }\n      .CodeMirror {\n        border: 1px solid #ddd;\n        border-radius: 3px;\n      }\n       .CodeMirror pre.CodeMirror-placeholder { color: #999; }\n    </style>\n    ';
      };
      return ContentBuilder;
    }();

    var presetLanguages = [
      {
        title: 'BASH',
        cmScriptFile: 'shell',
        langValue: 'bash',
        cmMode: 'text/x-sh'
      },
      {
        title: 'C',
        cmScriptFile: 'clike',
        langValue: 'c',
        cmMode: 'text/x-csrc'
      },
      {
        title: 'C#',
        cmScriptFile: 'clike',
        langValue: 'csharp',
        cmMode: 'text/x-csharp'
      },
      {
        title: 'C++',
        cmScriptFile: 'clike',
        langValue: 'cpp',
        cmMode: 'text/x-c++src'
      },
      {
        title: 'CMake',
        cmScriptFile: 'cmake',
        langValue: 'cmake',
        cmMode: 'text/x-cmake'
      },
      {
        title: 'CSS',
        cmScriptFile: 'css',
        langValue: 'css',
        cmMode: 'text/css'
      },
      {
        title: 'Dart',
        cmScriptFile: 'clike,dart',
        langValue: 'dart',
        cmMode: 'application/dart'
      },
      {
        title: 'Django',
        cmScriptFile: 'xml,htmlmixed,django',
        cmOtherScripts: ['addon/mode/overlay.js'],
        langValue: 'django',
        cmMode: 'django'
      },
      {
        title: 'Dockerfile',
        cmScriptFile: 'dockerfile',
        langValue: 'dockerfile',
        cmMode: 'text/x-dockerfile',
        cmOtherScripts: ['addon/mode/simple.js']
      },
      {
        title: 'Erlang',
        cmScriptFile: 'erlang',
        langValue: 'erlang',
        cmMode: 'text/x-erlang'
      },
      {
        title: 'F#',
        cmScriptFile: 'mllike',
        langValue: 'fsharp',
        cmMode: 'text/x-fsharp'
      },
      {
        title: 'Go',
        cmScriptFile: 'go',
        langValue: 'go',
        cmMode: 'text/x-go'
      },
      {
        title: 'HTML',
        cmScriptFile: 'xml',
        langValue: 'html',
        cmMode: 'text/html'
      },
      {
        title: 'HTTP',
        cmScriptFile: 'http',
        langValue: 'http',
        cmMode: 'message/http'
      },
      {
        title: 'INIFILE',
        cmScriptFile: '',
        langValue: 'ini',
        cmMode: ''
      },
      {
        title: 'Java',
        cmScriptFile: 'clike',
        langValue: 'java',
        cmMode: 'text/x-java'
      },
      {
        title: 'Javascript',
        cmScriptFile: 'javascript',
        langValue: 'javascript',
        cmMode: 'javascript'
      },
      {
        title: 'Json',
        cmScriptFile: 'javascript',
        langValue: 'json',
        cmMode: 'application/json'
      },
      {
        title: 'Less',
        cmScriptFile: 'less',
        langValue: 'less',
        cmMode: 'text/x-less'
      },
      {
        title: 'Lua',
        cmScriptFile: 'lua',
        langValue: 'lua',
        cmMode: 'text/x-lua'
      },
      {
        title: 'MSIL',
        cmScriptFile: '',
        langValue: 'msil',
        cmMode: ''
      },
      {
        title: 'Nginx',
        cmScriptFile: 'nginx',
        langValue: 'nginx',
        cmMode: 'text/x-nginx-conf'
      },
      {
        title: 'Objective-C',
        cmScriptFile: 'clike',
        langValue: 'objectivec',
        cmMode: 'text/x-objectivec'
      },
      {
        title: 'Pascal',
        cmScriptFile: 'pascal',
        langValue: 'pascal',
        cmMode: 'text/x-pascal'
      },
      {
        title: 'Perl',
        cmScriptFile: 'perl',
        langValue: 'perl',
        cmMode: 'text/x-perl'
      },
      {
        title: 'Php',
        cmScriptFile: 'php',
        langValue: 'php',
        cmMode: 'text/x-php'
      },
      {
        title: 'PlainText',
        cmScriptFile: '',
        langValue: 'plaintext',
        cmMode: ''
      },
      {
        title: 'PowerShell',
        cmScriptFile: 'powershell',
        langValue: 'powershell',
        cmMode: 'application/x-powershell'
      },
      {
        title: 'PowerQuery',
        cmScriptFile: '',
        langValue: 'powerquery',
        cmMode: ''
      },
      {
        title: 'Python',
        cmScriptFile: 'python',
        langValue: 'python',
        cmMode: 'text/x-python'
      },
      {
        title: 'Ruby',
        cmScriptFile: 'ruby',
        langValue: 'ruby',
        cmMode: 'text/x-ruby'
      },
      {
        title: 'Rust',
        cmScriptFile: 'rust',
        cmOtherScripts: ['addon/mode/simple.min.js'],
        langValue: 'rust',
        cmMode: 'text/x-rustsrc'
      },
      {
        title: 'SQL',
        cmScriptFile: 'sql',
        langValue: 'sql',
        cmMode: 'text/x-sql'
      },
      {
        title: 'Typescript',
        cmScriptFile: 'javascript',
        langValue: 'typescript',
        cmMode: 'application/typescript'
      },
      {
        title: 'VB.NET',
        cmScriptFile: 'vb',
        langValue: 'vbnet',
        cmMode: 'text/x-vb'
      },
      {
        title: 'Verilog',
        cmScriptFile: 'verilog',
        langValue: 'verilog',
        cmMode: 'text/x-verilog'
      },
      {
        title: 'VHDL',
        cmScriptFile: 'vhdl',
        langValue: 'vhdl',
        cmMode: 'text/x-vhdl'
      },
      {
        title: 'XML',
        cmScriptFile: 'xml',
        langValue: 'xml',
        cmMode: 'application/xml'
      },
      {
        title: 'YAML',
        cmScriptFile: 'yaml',
        langValue: 'yaml',
        cmMode: 'text/x-yaml'
      }
    ];

    var key = 'cnbCodeSampleSelectedLanguage';
    var SelectedLanguageStore = function () {
      function SelectedLanguageStore() {
      }
      Object.defineProperty(SelectedLanguageStore, 'instance', {
        get: function () {
          if (!this._instance) {
            this._instance = new SelectedLanguageStore();
          }
          return this._instance;
        },
        enumerable: false,
        configurable: true
      });
      SelectedLanguageStore.prototype.store = function (language) {
        globalThis.localStorage.setItem(key, language.langValue);
      };
      SelectedLanguageStore.prototype.clear = function () {
        globalThis.localStorage.removeItem(key);
      };
      SelectedLanguageStore.prototype.getStored = function () {
        var langValue = globalThis.localStorage.getItem(key);
        if (!langValue) {
          return undefined;
        }
        return presetLanguages.find(function (x) {
          return x.langValue === langValue;
        });
      };
      return SelectedLanguageStore;
    }();
    var selectedLanguageStore = SelectedLanguageStore.instance;

    var syntaxHighlighterClass = 'cnblogs_Highlighter';
    var cnblogsCodeClass = 'cnblogs_code';
    var isSyntaxHighlighterLoaded = false;
    var syntaxHighlighterLoadPromise = null;
    var loadSyntaxHighlighter = function (head, src) {
      return __awaiter(void 0, void 0, void 0, function () {
        var isSucceed;
        return __generator(this, function (_a) {
          switch (_a.label) {
          case 0:
            if (isSyntaxHighlighterLoaded !== false)
              return [
                2,
                isSyntaxHighlighterLoaded !== 'error'
              ];
            syntaxHighlighterLoadPromise !== null && syntaxHighlighterLoadPromise !== void 0 ? syntaxHighlighterLoadPromise : syntaxHighlighterLoadPromise = loadExternalScript('syntaxHighlighterScript', src, head);
            return [
              4,
              syntaxHighlighterLoadPromise
            ];
          case 1:
            isSucceed = _a.sent();
            isSyntaxHighlighterLoaded = isSucceed ? true : 'error';
            return [
              2,
              isSucceed
            ];
          }
        });
      });
    };
    var shBushPathPrepare = function () {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var result = [];
      for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
        var item = args_1[_a];
        result.push(item.replace('@', location.protocol + '//common.cnblogs.com/script/sh/'));
      }
      return result;
    };
    var syntaxHighlight = function (contentWindow, containerEl) {
      return __awaiter(void 0, void 0, void 0, function () {
        var highlighter;
        return __generator(this, function (_a) {
          highlighter = contentWindow.SyntaxHighlighter;
          if (!highlighter) {
            return [2];
          }
          containerEl.querySelectorAll('pre[class*="brush:"]').forEach(function (preEl) {
            var _a, _b;
            if (preEl.innerHTML.indexOf('<span') >= 0) {
              preEl.textContent = (_a = preEl.innerHTML) !== null && _a !== void 0 ? _a : '';
            }
            if (preEl.className.includes('gutter:true')) {
              (_b = preEl.parentElement) === null || _b === void 0 ? void 0 : _b.classList.add('sh-gutter');
            }
          });
          highlighter.autoloader.apply(null, shBushPathPrepare('applescript\t\t\t    @shBrushAppleScript.js', 'actionscript3 as3\t\t@shBrushAS3.js', 'bash shell\t\t\t\t@shBrushBash.js', 'coldfusion cf\t\t\t@shBrushColdFusion.js', 'cpp c\t\t\t\t\t@shBrushCpp.js', 'c# c-sharp csharp\t\t@shBrushCSharp.js', 'css\t\t\t\t\t    @shBrushCss.js', 'delphi pascal pas\t\t@shBrushDelphi.js', 'diff patch       \t\t@shBrushDiff.js', 'erl erlang\t\t\t\t@shBrushErlang.js', 'groovy\t\t\t\t\t@shBrushGroovy.js', 'java\t\t\t\t\t    @shBrushJava.js', 'jfx javafx\t\t\t\t@shBrushJavaFX.js', 'js jscript javascript\t@shBrushJScript.js', 'perl pl Perl\t\t\t\t@shBrushPerl.js', 'php\t\t\t\t\t    @shBrushPhp.js', 'text plain\t\t\t\t@shBrushPlain.js', 'py python\t\t\t\t@shBrushPython.js', 'ruby rails ror rb\t\t@shBrushRuby.js', 'sass scss\t\t\t\t@shBrushSass.js', 'scala\t\t\t\t\t@shBrushScala.js', 'sql\t\t\t\t\t    @shBrushSql.js', 'vb vbnet\t\t\t\t    @shBrushVb.js', 'xml xhtml xslt html\t    @shBrushXml.js?id=20150508', 'objc obj-c               @shBrushObjectiveC.js', 'f# f-sharp fsharp        @shBrushFSharp.js', 'xpp dynamics-xpp         @shBrushDynamics.js', 'r s splus                @shBrushR.js', 'matlab                   @shBrushMatlab.js', 'swift                    @shBrushSwift.js', 'go golang                @shBrushGo.js', 'mathematica              @shBrushMathematica.js'));
          highlighter.config.strings.expandSource = '+ View Code';
          highlighter.vars.discoveredBrushes = null;
          highlighter.defaults['auto-links'] = false;
          highlighter.defaults['quick-code'] = false;
          highlighter.all();
          return [2];
        });
      });
    };
    var legacyCodeBlock;
    (function (legacyCodeBlock_1) {
      var _this = this;
      (function (selector) {
        selector.syntaxHighlighter = '.'.concat(syntaxHighlighterClass);
        selector.cnblogsCode = '.'.concat(cnblogsCodeClass);
        selector.selectedCnblogsCode = ''.concat(selector.cnblogsCode, '[data-mce-selected]');
      }(legacyCodeBlock_1.selector || (legacyCodeBlock_1.selector = {})));
      (function (syntaxHighlighter) {
        syntaxHighlighter.fixUnWrappedBlocks = function (editor) {
          editor.$(':not(.'.concat(syntaxHighlighterClass, ')>pre[class*="brush:"]')).each(function (idx, el) {
            el.outerHTML = '<div class="'.concat(syntaxHighlighterClass, '">').concat(el.outerHTML, '</div>');
          });
        };
      }(legacyCodeBlock_1.syntaxHighlighter || (legacyCodeBlock_1.syntaxHighlighter = {})));
      var LegacyCodeBlockId;
      (function (LegacyCodeBlockId) {
        LegacyCodeBlockId[LegacyCodeBlockId['syntaxHighlighter'] = 0] = 'syntaxHighlighter';
        LegacyCodeBlockId[LegacyCodeBlockId['cnblogsCode'] = 1] = 'cnblogsCode';
      }(LegacyCodeBlockId = legacyCodeBlock_1.LegacyCodeBlockId || (legacyCodeBlock_1.LegacyCodeBlockId = {})));
      var isSyntaxHighlighter = function (el) {
        var _a, _b;
        return el.className.includes('brush:') || !!((_b = (_a = el.parentElement) === null || _a === void 0 ? void 0 : _a.classList) === null || _b === void 0 ? void 0 : _b.contains(syntaxHighlighterClass));
      };
      var isCnblogsCode = function (el) {
        var _a;
        if (isPreElement(el) && ((_a = el.parentElement) === null || _a === void 0 ? void 0 : _a.classList.contains(cnblogsCodeClass)) && !isSpanElement(el.parentElement))
          return true;
        var maxDepth = 10;
        var parentEl = el.parentElement;
        var depth = 0;
        while (parentEl && depth++ < maxDepth) {
          if (isDivElement(parentEl) && parentEl.classList.contains(cnblogsCodeClass))
            return true;
          parentEl = parentEl.parentElement;
        }
        return false;
      };
      legacyCodeBlock_1.markUnEditable = function (editor) {
        editor.$('.'.concat(syntaxHighlighterClass, ' pre,:not(.').concat(syntaxHighlighterClass, ')>pre[class*="brush:"]'), editor.getDoc()).each(function (_, elm) {
          var legacyCodeBlock = legacyCodeBlock_1.isLegacyCodeBlock(elm);
          if (legacyCodeBlock) {
            removeContentEditableAttribute(elm);
            markContentUnEditable(legacyCodeBlock.containerElement);
            if (!legacyCodeBlock.containerElement)
              markContentUnEditable(legacyCodeBlock.targetElement);
          }
        });
      };
      legacyCodeBlock_1.isLegacyCodeBlock = function (el) {
        if (!el) {
          return false;
        }
        if (isPreElement(el)) {
          if (isSyntaxHighlighter(el)) {
            return {
              id: LegacyCodeBlockId.syntaxHighlighter,
              containerElement: el.parentElement,
              targetElement: el
            };
          }
          if (isCnblogsCode(el)) {
            return {
              id: LegacyCodeBlockId.cnblogsCode,
              containerElement: el.parentElement,
              targetElement: el
            };
          }
        }
        if (isSpanElement(el) && !el.classList.contains('cnblogs_code_collapse') && isCnblogsCode(el)) {
          return {
            id: LegacyCodeBlockId.cnblogsCode,
            containerElement: el.parentElement.parentElement,
            targetElement: el.parentElement
          };
        }
        if (el.classList.contains(syntaxHighlighterClass)) {
          return {
            id: LegacyCodeBlockId.syntaxHighlighter,
            containerElement: el,
            targetElement: el.firstElementChild
          };
        }
        if (el.classList.contains(cnblogsCodeClass) && !isSpanElement(el)) {
          var preEl = function () {
            return el.querySelector('pre');
          };
          if (!preEl()) {
            el.innerHTML = '<pre>'.concat(el.innerHTML, '</pre>');
          }
          return {
            id: LegacyCodeBlockId.cnblogsCode,
            containerElement: el,
            targetElement: preEl()
          };
        }
        return false;
      };
      legacyCodeBlock_1.highlight = function (editor, settings) {
        return __awaiter(_this, void 0, void 0, function () {
          return __generator(this, function (_a) {
            switch (_a.label) {
            case 0:
              return [
                4,
                loadSyntaxHighlighter(editor.getWin().document.head, settings.syntaxHighlighterPath)
              ];
            case 1:
              _a.sent();
              return [
                4,
                syntaxHighlight(editor.getWin(), editor.getBody())
              ];
            case 2:
              _a.sent();
              return [2];
            }
          });
        });
      };
      legacyCodeBlock_1.insertCodeMirrorValueToEditor = function (legacyCodeId, codeLanguage, isShowLineNumbers, isFold, editor, settings) {
        var cmEditor = ContentBuilder.cmEditor;
        if (cmEditor) {
          var value = htmlEncode(cmEditor.getValue());
          var content = '';
          switch (legacyCodeId) {
          case legacyCodeBlock.LegacyCodeBlockId.syntaxHighlighter:
            content = '<div class="'.concat(syntaxHighlighterClass, '"><pre class="brush:').concat(codeLanguage, ';gutter:').concat(isShowLineNumbers, ';collapse:').concat(isFold, '">').concat(value, '</pre></div>');
            break;
          }
          editor.insertContent(content);
          editor.selection.select(editor.$('#__new').removeAttr('id')[0]);
          if (settings.insertNewline) {
            editor.selection.collapse(false);
            editor.insertContent('\n', true);
          }
        }
      };
      legacyCodeBlock_1.parseCodeLanguage = function (legacyBlock) {
        var _a, _b, _c;
        if (!legacyBlock)
          return;
        var id = legacyBlock.id, targetElement = legacyBlock.targetElement;
        var className = '';
        var codeLanguage = '';
        switch (id) {
        case legacyCodeBlock.LegacyCodeBlockId.syntaxHighlighter: {
            if (targetElement instanceof HTMLPreElement) {
              className = targetElement.className;
              var startIdx = className.indexOf('brush:') + 'brush:'.length;
              var endIdx = className.indexOf(';', startIdx);
              endIdx = endIdx < 0 ? className.length : endIdx;
              codeLanguage = className.substring(startIdx, endIdx);
            } else {
              codeLanguage = (_b = (_a = targetElement.querySelector('.container .line code')) === null || _a === void 0 ? void 0 : _a.classList[0]) !== null && _b !== void 0 ? _b : '';
            }
          }
          break;
        case legacyCodeBlock.LegacyCodeBlockId.cnblogsCode:
          codeLanguage = 'plaintext';
          break;
        }
        return (_c = presetLanguages.find(function (x) {
          return x.langValue === codeLanguage;
        })) !== null && _c !== void 0 ? _c : presetLanguages.find(function (x) {
          return x.langValue === 'plaintext';
        });
      };
      legacyCodeBlock_1.parseSyntaxHighlighterOptions = function (legacyBlock) {
        var collapsed = false;
        var gutter = false;
        if (legacyBlock && legacyBlock.id === LegacyCodeBlockId.syntaxHighlighter) {
          var containerElement = legacyBlock.containerElement, targetElement = legacyBlock.targetElement;
          if (isPreElement(targetElement)) {
            collapsed = targetElement.className.includes('collapse:true');
            gutter = targetElement.className.includes('gutter:true');
          } else {
            var wrapperEl = targetElement.querySelector('.syntaxhighlighter');
            collapsed = !!(wrapperEl === null || wrapperEl === void 0 ? void 0 : wrapperEl.querySelector('.command_expandSource.expandSource'));
            gutter = !!(containerElement === null || containerElement === void 0 ? void 0 : containerElement.querySelector('.gutter'));
          }
        }
        return {
          collapsed: collapsed,
          gutter: gutter
        };
      };
      legacyCodeBlock_1.resolveCodeText = function (legacyBlock) {
        var _a, _b;
        var targetElement = legacyBlock.targetElement, id = legacyBlock.id;
        switch (id) {
        case legacyCodeBlock.LegacyCodeBlockId.syntaxHighlighter:
          if (targetElement instanceof HTMLPreElement)
            return (_a = targetElement.textContent) !== null && _a !== void 0 ? _a : '';
          return Array.from(targetElement.querySelectorAll('.container .line')).map(function (x) {
            return Array.from(x.querySelectorAll('code')).map(function (codeEl) {
              var _a, _b, _c;
              return (_c = codeEl.classList.contains('spaces') ? new Array((_b = (_a = codeEl.textContent) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0).join(' ') : codeEl.textContent) !== null && _c !== void 0 ? _c : '';
            }).join(' ');
          }).join('\n');
        case legacyCodeBlock.LegacyCodeBlockId.cnblogsCode:
          return (_b = targetElement.textContent) !== null && _b !== void 0 ? _b : '';
        }
      };
      legacyCodeBlock_1.appendWhiteSpaceForInlineCnblogsCode = function (editor) {
        editor.$('span.'.concat(cnblogsCodeClass)).each(function (idx, el) {
          var _a, _b;
          var sibling = (_b = (_a = el.nextSibling) === null || _a === void 0 ? void 0 : _a.textContent) !== null && _b !== void 0 ? _b : '';
          if (sibling.startsWith(' ') || sibling.startsWith('\xA0') || sibling.startsWith('&nbsp;')) {
            return;
          }
          el.insertAdjacentHTML('afterend', '&nbsp;');
        });
      };
    }(legacyCodeBlock || (legacyCodeBlock = {})));
    var legacyCodeBlock$1 = legacyCodeBlock;

    var isLegacyCodeBlock = legacyCodeBlock$1.isLegacyCodeBlock;
    var Prism;
    var loadPrism = function (editor, setting) {
      return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
          case 0:
            if (!!setting.prism.useGlobal)
              return [
                3,
                2
              ];
            return [
              4,
              loadExternalScript('prism-script', ''.concat(setting.prism.basePath, '/prism.min.js'), editor.contentDocument.head, function (s) {
                s.setAttribute('data-manual', '');
              })
            ];
          case 1:
            _a.sent();
            Prism = editor.contentWindow['Prism'];
            return [
              3,
              3
            ];
          case 2:
            Prism = window['Prism'];
            _a.label = 3;
          case 3:
            if (!!Prism.plugins.autoloader)
              return [
                3,
                5
              ];
            return [
              4,
              loadExternalScript('prismjs-autoloader', ''.concat(setting.prism.basePath, '/plugins/autoloader/prism-autoloader.min.js'), setting.prism.useGlobal ? document.head : editor.contentDocument.head)
            ];
          case 4:
            _a.sent();
            _a.label = 5;
          case 5:
            Prism.plugins.autoloader.languages_path = ''.concat(setting.prism.basePath, '/components/');
            return [
              2,
              Prism
            ];
          }
        });
      });
    };
    var initPluginSettings = function (editor) {
      var _a;
      var setting = Object.assign({
        languages: presetLanguages,
        mergeWithDefaultLanguages: true,
        codeMirrorBasePath: 'https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.59.4',
        prism: {
          useGlobal: false,
          basePath: 'https://cdn.jsdelivr.net/npm/prismjs@1.23.0'
        },
        rememberLastSelectedLanguage: true,
        insertNewline: true,
        syntaxHighlighterPath: 'https://www.cnblogs.com/js/common-begin.js',
        autoRemoveEmptyCodeBlock: true
      }, editor.settings.cnbCodeSample);
      (_a = setting.languages) !== null && _a !== void 0 ? _a : setting.languages = [];
      if (setting.mergeWithDefaultLanguages) {
        presetLanguages.forEach(function (l) {
          if (!setting.languages.find(function (x) {
              return x.langValue === l.langValue;
            })) {
            setting.languages.push(l);
          }
        });
      }
      if (!setting.highlightCodeBlock) {
        setting.highlightCodeBlock = function (preEl) {
          return __awaiter(void 0, void 0, void 0, function () {
            var prism;
            return __generator(this, function (_a) {
              switch (_a.label) {
              case 0:
                return [
                  4,
                  loadPrism(editor, setting)
                ];
              case 1:
                prism = _a.sent();
                prism.highlightElement(preEl);
                return [2];
              }
            });
          });
        };
      }
      return setting;
    };
    var getSelectedLanguage = function (editor) {
      var _a, _b, _c, _d, _e;
      var selectionNode = editor.selection.getNode();
      var preEl = isPreElement(selectionNode) ? selectionNode : selectionNode.querySelector('pre');
      var content = preEl === null || preEl === void 0 ? void 0 : preEl.innerText;
      if (content) {
        var prefix_1 = 'language-';
        var splitLang_1 = (_d = __spreadArray(__spreadArray([], Array.from((_b = (_a = preEl.firstElementChild) === null || _a === void 0 ? void 0 : _a.classList) !== null && _b !== void 0 ? _b : []), true), Array.from((_c = preEl.classList) !== null && _c !== void 0 ? _c : []), true).find(function (x) {
          return x.startsWith(prefix_1);
        })) === null || _d === void 0 ? void 0 : _d.replace(prefix_1, '');
        return (_e = presetLanguages.find(function (x) {
          return x.langValue === splitLang_1;
        })) !== null && _e !== void 0 ? _e : presetLanguages.find(function (x) {
          return x.langValue === 'plaintext';
        });
      } else {
        return selectedLanguageStore.getStored();
      }
    };
    var setCodeMirrorMode = function (language, settings) {
      var _a;
      var loadOtherScriptsTasks = [Promise.resolve()];
      (_a = language.cmOtherScripts) === null || _a === void 0 ? void 0 : _a.forEach(function (s) {
        var _a;
        s = s.trim();
        if (!s)
          return;
        var headEl = (_a = ContentBuilder.iframe.contentDocument) === null || _a === void 0 ? void 0 : _a.head;
        if (!headEl)
          return;
        var tagId = s.split('/').pop();
        loadOtherScriptsTasks.push(loadExternalScript(''.concat(tagId), ''.concat(settings.codeMirrorBasePath, '/').concat(s), headEl));
      });
      Promise.all(loadOtherScriptsTasks).then(function () {
        var scriptLoadTasks = [];
        language.cmScriptFile.split(',').forEach(function (s) {
          var _a;
          s = s.trim();
          if (!s)
            return;
          var headEl = (_a = ContentBuilder.iframe.contentDocument) === null || _a === void 0 ? void 0 : _a.head;
          if (!headEl)
            return;
          scriptLoadTasks.push(loadExternalScript(''.concat(s, '-script'), ''.concat(settings.codeMirrorBasePath, '/mode/').concat(s, '/').concat(s, '.min.js'), headEl));
        });
        Promise.all(scriptLoadTasks).then(function () {
          var _a;
          (_a = ContentBuilder.cmEditor) === null || _a === void 0 ? void 0 : _a.setOption('mode', language.cmMode);
        });
      });
    };
    var setCodeMirrorContent = function (content) {
      var _a;
      (_a = ContentBuilder.cmEditor) === null || _a === void 0 ? void 0 : _a.setValue(content);
    };
    var isCnbCodeSample = function (el) {
      if (!el)
        return false;
      if (isPreElement(el) || isDetailsElement(el)) {
        return !isLegacyCodeBlock(el);
      } else {
        var parentEl = el.parentElement;
        var maxDepth = 4;
        var depth = 0;
        while (parentEl && depth++ < maxDepth) {
          if (isPreElement(parentEl) && !isLegacyCodeBlock(parentEl))
            return true;
          parentEl = parentEl.parentElement;
        }
      }
      return false;
    };

    var setup$2 = function (editor, settings) {
      var $ = editor.$;
      editor.on('PreProcess', function (preProcessEvent) {
        $('pre[contenteditable=false], details[contenteditable=false] pre', preProcessEvent.node).filter(function (_, elm) {
          return isCnbCodeSample(elm);
        }).each(function (idx, el) {
          var _a;
          var code = el.textContent;
          el.className = editor.$.trim(el.className);
          removeContentEditableAttribute(el);
          var codeEl = editor.contentDocument.createElement('code');
          codeEl.textContent = code;
          el.innerHTML = '';
          el.append(codeEl);
          if (((_a = el.parentElement) === null || _a === void 0 ? void 0 : _a.tagName.toLowerCase()) === 'details') {
            var detailEl = el.parentElement;
            detailEl.removeAttribute('data-mce-open');
            detailEl.removeAttribute('open');
            removeContentEditableAttribute(el.parentElement);
          }
        });
        $(''.concat(legacyCodeBlock$1.selector.syntaxHighlighter, '[contenteditable=false]'), preProcessEvent.node).each(function (idx, el) {
          var _a, _b;
          if (el.firstChild instanceof HTMLPreElement)
            return;
          var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(el);
          el.className = editor.$.trim(el.className);
          removeContentEditableAttribute(el);
          if (legacyBlock) {
            var code = legacyCodeBlock$1.resolveCodeText(legacyBlock);
            var preEl = editor.contentDocument.createElement('pre');
            var _c = legacyCodeBlock$1.parseSyntaxHighlighterOptions(legacyBlock), collapsed = _c.collapsed, gutter = _c.gutter;
            var brush = (_b = (_a = el.querySelector('.container .line code')) === null || _a === void 0 ? void 0 : _a.classList[0]) !== null && _b !== void 0 ? _b : 'plaintext';
            preEl.className = 'brush:'.concat(brush, ';gutter:').concat(gutter, ';collapse:').concat(collapsed);
            preEl.innerHTML = code;
            el.innerHTML = '';
            el.append(preEl);
          }
        });
      });
      editor.on('SetContent', function () {
        legacyCodeBlock$1.syntaxHighlighter.fixUnWrappedBlocks(editor);
        legacyCodeBlock$1.appendWhiteSpaceForInlineCnblogsCode(editor);
        $('details').each(function (_, el) {
          return markContentUnEditable(el);
        });
        if (settings.codeHighlightThemeHref) {
          var linkEl = editor.contentDocument.querySelector('#code-theme');
          if (!linkEl || linkEl.href !== settings.codeHighlightThemeHref) {
            linkEl === null || linkEl === void 0 ? void 0 : linkEl.remove();
            linkEl = editor.contentDocument.createElement('link');
            linkEl.id = 'code-theme';
            linkEl.rel = 'stylesheet';
            linkEl.href = settings.codeHighlightThemeHref;
            editor.contentDocument.head.append(linkEl);
          }
        }
        var unprocessedCodeSamples = $('pre').filter(function (_, elm) {
          return isCnbCodeSample(elm) && hasNoUnEditableAttribute(elm);
        });
        if (unprocessedCodeSamples.length) {
          editor.undoManager.transact(function () {
            unprocessedCodeSamples.each(function (idx, preEl) {
              return __awaiter(void 0, void 0, void 0, function () {
                var $preEl, $codeEl, html;
                return __generator(this, function (_a) {
                  switch (_a.label) {
                  case 0:
                    $preEl = $(preEl);
                    $codeEl = $preEl.children('code');
                    if ($codeEl.length <= 0) {
                      $preEl.html('<code>'.concat(editor.dom.encode($preEl.text()), '</code>'));
                      $codeEl = $preEl.children('code');
                    }
                    if (settings.autoRemoveEmptyCodeBlock && !$preEl.text().trim()) {
                      $preEl.remove();
                      return [2];
                    }
                    $preEl.find('br').each(function (idx, elm) {
                      if (elm.parentNode) {
                        elm.parentNode.replaceChild(editor.getDoc().createTextNode('\n'), elm);
                      }
                    });
                    html = $preEl.html();
                    $preEl.html(html.replace(/\n+<\/\s*code>$/g, '</code>'));
                    markContentUnEditable(isDetailsElement(preEl.parentElement) ? preEl.parentElement : preEl);
                    $codeEl.html(editor.dom.encode($codeEl.text()));
                    return [
                      4,
                      settings.highlightCodeBlock(preEl, editor)
                    ];
                  case 1:
                    _a.sent();
                    preEl.className = editor.$.trim(preEl.className);
                    return [2];
                  }
                });
              });
            });
          });
        }
        legacyCodeBlock$1.markUnEditable(editor);
        legacyCodeBlock$1.highlight(editor, settings).then();
      });
    };

    var insertContentToEditor = function (editor, settings, language) {
      if (language === void 0) {
        language = 'plaintext';
      }
      var cmEditor = ContentBuilder.cmEditor;
      if (cmEditor) {
        var value = htmlEncode(cmEditor.getValue());
        if (!value || !value.trim()) {
          return;
        }
        var content = '<pre '.concat(Dialog.foldCode ? '' : 'id=\'__new\'', ' class="language-').concat(language, '"><code>').concat(value, '</code></pre>');
        content = Dialog.foldCode ? '<details><summary>'.concat(Dialog.foldCodeTitle, '</summary>').concat(content, '</details>') : content;
        editor.insertContent(content);
        editor.selection.select(editor.$('#__new').removeAttr('id')[0]);
        if (settings.insertNewline) {
          editor.selection.collapse(false);
          editor.insertContent('\n', true);
        }
      }
    };
    var defaultFoldCodeTitle = '\u67e5\u770b\u4ee3\u7801';
    var defaultFoldCode = false;
    var Dialog = function () {
      function Dialog() {
      }
      Dialog.initFoldCodeOptions = function (selectionNode) {
        var _a;
        var summaryEl = selectionNode.querySelector('summary');
        if (summaryEl) {
          this.foldCode = true;
          this.foldCodeTitle = (_a = summaryEl === null || summaryEl === void 0 ? void 0 : summaryEl.textContent) !== null && _a !== void 0 ? _a : '';
        } else {
          this.foldCode = defaultFoldCode;
          this.foldCodeTitle = '';
        }
      };
      Dialog.open = function (editor, settings, selectedLanguage) {
        if (selectedLanguage === void 0) {
          selectedLanguage = undefined;
        }
        return __awaiter(this, void 0, void 0, function () {
          var iframeContent, dialogApi;
          return __generator(this, function (_a) {
            switch (_a.label) {
            case 0:
              iframeContent = new ContentBuilder(editor, settings).build();
              selectedLanguage !== null && selectedLanguage !== void 0 ? selectedLanguage : selectedLanguage = presetLanguages[0];
              this.initFoldCodeOptions(editor.selection.getNode());
              dialogApi = editor.windowManager.open({
                title: '\u63d2\u5165\u4ee3\u7801\u5757',
                size: 'large',
                body: {
                  type: 'panel',
                  items: [
                    {
                      type: 'selectbox',
                      name: 'language',
                      label: '\u7f16\u7a0b\u8bed\u8a00',
                      items: settings.languages.map(function (x) {
                        return Object.assign({
                          text: x.title,
                          value: x.langValue
                        });
                      })
                    },
                    {
                      type: 'bar',
                      items: [
                        {
                          type: 'label',
                          label: '',
                          items: [{
                              name: 'isFoldCode',
                              label: '\u6298\u53e0\u6b64\u4ee3\u7801\u5757',
                              type: 'checkbox'
                            }]
                        },
                        {
                          type: 'label',
                          label: '&nbsp;&nbsp;&nbsp;&nbsp;\u6298\u53e0\u6807\u9898',
                          items: []
                        },
                        {
                          name: 'foldTitle',
                          label: '',
                          type: 'input',
                          disabled: !Dialog.foldCode,
                          placeholder: '\u5728\u6b64\u8f93\u5165\u6298\u53e0\u6807\u9898'
                        }
                      ]
                    },
                    {
                      name: 'cmCodeEditor',
                      type: 'iframe',
                      sandboxed: true,
                      label: ''
                    }
                  ]
                },
                buttons: [
                  {
                    type: 'cancel',
                    name: 'cancel',
                    text: '\u53d6\u6d88'
                  },
                  {
                    type: 'submit',
                    name: 'save',
                    text: '\u4fdd\u5b58',
                    primary: true
                  }
                ],
                onSubmit: function () {
                  insertContentToEditor(editor, settings, selectedLanguage.langValue);
                  dialogApi.close();
                },
                onChange: function (api) {
                  selectedLanguage = settings.languages.find(function (x) {
                    return x.langValue === api.getData().language;
                  });
                  var _a = api.getData(), isFoldCode = _a.isFoldCode, foldTitle = _a.foldTitle;
                  Dialog.foldCode = isFoldCode;
                  Dialog.foldCode ? api.enable('foldTitle') : api.disable('foldTitle');
                  Dialog.foldCodeTitle = foldTitle ? foldTitle : defaultFoldCodeTitle;
                  setCodeMirrorMode(selectedLanguage, settings);
                  if (settings.rememberLastSelectedLanguage) {
                    selectedLanguageStore.store(selectedLanguage);
                  } else {
                    selectedLanguageStore.clear();
                  }
                },
                onClose: function () {
                  Dialog.foldCode = defaultFoldCode;
                  Dialog.foldCodeTitle = defaultFoldCodeTitle;
                },
                initialData: {
                  cmCodeEditor: iframeContent,
                  language: selectedLanguage.langValue,
                  isFoldCode: Dialog.foldCode,
                  foldTitle: Dialog.foldCodeTitle
                }
              });
              ContentBuilder.iframe.onload = function () {
                var _a, _b, _c;
                setCodeMirrorMode(selectedLanguage, settings);
                var node = editor.selection.getNode();
                if ((node === null || node === void 0 ? void 0 : node.nodeName) === 'DETAILS')
                  node = node.querySelector('pre');
                if (isCnbCodeSample(node)) {
                  setCodeMirrorContent((_b = (_a = node.textContent) === null || _a === void 0 ? void 0 : _a.trim()) !== null && _b !== void 0 ? _b : '');
                } else {
                  dialogApi.disable('save');
                }
                (_c = ContentBuilder.cmEditor) === null || _c === void 0 ? void 0 : _c.on('change', function (cmEditor) {
                  var value = cmEditor.getValue();
                  if (!value) {
                    dialogApi.disable('save');
                  } else {
                    dialogApi.enable('save');
                  }
                });
              };
              if (!!settings.highlightCodeBlock)
                return [
                  3,
                  2
                ];
              return [
                4,
                loadPrism(editor, settings)
              ];
            case 1:
              _a.sent();
              _a.label = 2;
            case 2:
              tinymce.dom.DomQuery('.tox-dialog').addClass('cnb-code-sample');
              return [2];
            }
          });
        });
      };
      Dialog.foldCode = defaultFoldCode;
      Dialog.foldCodeTitle = '';
      return Dialog;
    }();

    var LegacyCodeBlockId$1 = legacyCodeBlock$1.LegacyCodeBlockId;
    var syntaxHighlighterDialog;
    (function (syntaxHighlighterDialog) {
      syntaxHighlighterDialog.open = function (editor, settings, selectedLanguage) {
        var iframeContent = new ContentBuilder(editor, settings).build();
        selectedLanguage !== null && selectedLanguage !== void 0 ? selectedLanguage : selectedLanguage = presetLanguages[0];
        var node = editor.selection.getNode();
        var foldCode = false;
        var showLineNumbers = true;
        var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(node);
        if (legacyBlock) {
          var options = legacyCodeBlock$1.parseSyntaxHighlighterOptions(legacyBlock);
          foldCode = options.collapsed;
          showLineNumbers = options.gutter;
        }
        var dialogApi = editor.windowManager.open({
          title: '\u63d2\u5165\u4ee3\u7801\u5757',
          size: 'large',
          body: {
            type: 'panel',
            items: [
              {
                type: 'selectbox',
                name: 'language',
                label: '\u7f16\u7a0b\u8bed\u8a00',
                items: settings.languages.map(function (x) {
                  return Object.assign({
                    text: x.title,
                    value: x.langValue
                  });
                })
              },
              {
                type: 'bar',
                items: [
                  {
                    name: 'isFoldCode',
                    label: '\u6298\u53e0\u6b64\u4ee3\u7801\u5757',
                    type: 'checkbox'
                  },
                  {
                    name: 'showLineNumbers',
                    label: '\u663e\u793a\u884c\u53f7',
                    type: 'checkbox'
                  }
                ]
              },
              {
                name: 'cmCodeEditor',
                type: 'iframe',
                sandboxed: true,
                label: '\u4ee3\u7801'
              }
            ]
          },
          buttons: [
            {
              type: 'cancel',
              name: 'cancel',
              text: '\u53d6\u6d88'
            },
            {
              type: 'submit',
              name: 'save',
              text: '\u4fdd\u5b58',
              primary: true
            }
          ],
          initialData: {
            cmCodeEditor: iframeContent,
            language: selectedLanguage.langValue,
            isFoldCode: foldCode,
            showLineNumbers: showLineNumbers
          },
          onChange: function (api) {
            foldCode = api.getData().isFoldCode;
            showLineNumbers = api.getData().showLineNumbers;
          },
          onSubmit: function () {
            legacyCodeBlock$1.insertCodeMirrorValueToEditor(LegacyCodeBlockId$1.syntaxHighlighter, selectedLanguage.langValue, showLineNumbers, foldCode, editor, settings);
            dialogApi.close();
          }
        });
        ContentBuilder.iframe.onload = function () {
          var _a;
          setCodeMirrorMode(selectedLanguage, settings);
          var node = editor.selection.getNode();
          var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(node);
          if (legacyBlock && legacyBlock.id === LegacyCodeBlockId$1.syntaxHighlighter) {
            setCodeMirrorContent(legacyCodeBlock$1.resolveCodeText(legacyBlock));
          } else {
            dialogApi.disable('save');
          }
          (_a = ContentBuilder.cmEditor) === null || _a === void 0 ? void 0 : _a.on('change', function (cmEditor) {
            var value = cmEditor.getValue();
            if (!value) {
              dialogApi.disable('save');
            } else {
              dialogApi.enable('save');
            }
          });
        };
        tinymce.dom.DomQuery('.tox-dialog').addClass('cnb-code-sample');
        return Promise.resolve();
      };
    }(syntaxHighlighterDialog || (syntaxHighlighterDialog = {})));

    var LegacyCodeBlockId = legacyCodeBlock$1.LegacyCodeBlockId;
    var registerIcon = function (editor) {
      editor.ui.registry.addIcon('cnb-code-sample', '<svg class="icon" viewBox="0 0 1024 1024" width="23" height="23" focusable="false"><path d="M240.5 552l184.3 79.89999999999998c1.6999999999999886 0.7000000000000455 3-0.1999999999999318 3-2v-47c0-1.7999999999999545-1.400000000000034-3.7999999999999545-3.1000000000000227-4.5l-126.5-49.799999999999955c-1.6999999999999886-0.7000000000000455-1.6999999999999886-1.7000000000000455 0-2.3999999999999773l126.5-48.700000000000045c1.6999999999999886-0.6999999999999886 3.1000000000000227-2.6000000000000227 3.1000000000000227-4.5v-47.39999999999998c0-1.8000000000000114-1.3000000000000114-2.7000000000000455-3-2l-184.3 79.89999999999998c-1.6999999999999886 0.6999999999999886-3 2.8000000000000114-3 4.600000000000023v39.19999999999993c0 1.900000000000091 1.3000000000000114 3.900000000000091 3 4.7000000000000455z m229.5 117.60000000000002c5.199999999999989 0 9.100000000000023-1.2000000000000455 11.800000000000011-3.5 2.6999999999999886-2.300000000000068 4.699999999999989-5.600000000000023 6.099999999999966-9.700000000000045 1.3000000000000114-4.100000000000023 2.900000000000034-9.799999999999955 4.600000000000023-17l53-218.09999999999997c2.6000000000000227-10.300000000000011 4-17.5 4-21.400000000000034 0-5.2999999999999545-1.7000000000000455-9.5-5-12.5-3.3999999999999773-3-8.200000000000045-4.5-14.5-4.5-7.2999999999999545 0-12.200000000000045 2.1000000000000227-14.799999999999955 6.5-2.5 4.300000000000011-5.100000000000023 12.200000000000045-7.900000000000034 23.80000000000001l-52.80000000000001 218.09999999999997c-2.5 11.600000000000023-3.8000000000000114 18.800000000000068-3.8000000000000114 21.700000000000045 0 11.100000000000023 6.400000000000034 16.600000000000023 19.30000000000001 16.600000000000023z m105.20000000000005-37.39999999999998l184.29999999999995-80.20000000000005c1.7000000000000455-0.7000000000000455 3-2.7999999999999545 3-4.600000000000023v-38.799999999999955c0-1.8000000000000114-1.2999999999999545-3.900000000000034-3-4.600000000000023l-184.29999999999995-79.5c-1.7000000000000455-0.6999999999999886-3 0.19999999999998863-3 2v46.5c0 1.8000000000000114 1.3999999999999773 3.8000000000000114 3.099999999999909 4.5l126.90000000000009 49.10000000000002c1.6999999999999318 0.6999999999999318 1.6999999999999318 1.6999999999999318 0 2.3999999999999773l-126.90000000000009 49.799999999999955c-1.6999999999999318 0.7000000000000455-3.099999999999909 2.7000000000000455-3.099999999999909 4.5v47c0 1.7000000000000455 1.2999999999999545 2.6000000000000227 3 1.900000000000091z m309.79999999999995-517.2h-770c-29 0-52.5 23.5-52.5 52.5v665c0 29 23.5 52.5 52.5 52.5h770c29 0 52.5-23.5 52.5-52.5v-665c0-29-23.5-52.5-52.5-52.5z m0 717.5h-770v-577.5h770v577.5z"></path></svg>');
      editor.ui.registry.addIcon('insert-new-line', '<svg class="icon" viewBox="0 0 1024 1024" width="23" height="23" focusable="false"><path d="M900.2 385.8v-192c0-22.1-17.9-40-40-40s-40 17.9-40 40v192c0 59.4-23.1 115.3-65.2 157.4-42 42-97.9 65.2-157.4 65.2H258.2l112.4-112.3c15.6-15.7 15.6-41 0-56.6-7.8-7.8-18-11.7-28.3-11.7s-20.5 3.9-28.3 11.7L135.5 618c-7.5 7.5-11.7 17.7-11.7 28.3s4.2 20.8 11.7 28.3l183.7 183.8c15.7 15.6 41 15.7 56.6 0s15.6-41 0-56.6L262.4 688.4h335.2c80.8 0 156.8-31.4 214-88.6s88.7-133.2 88.6-214z"></path></svg>');
    };
    var registerContextToolbar = function (editor, settings) {
      editor.ui.registry.addButton('delete-code-block', {
        onAction: function () {
          editor.windowManager.confirm('\u786e\u5b9a\u8981\u5220\u9664\u8fd9\u4e2a\u4ee3\u7801\u5757\u5417?', function (isConfirmed) {
            if (isConfirmed) {
              editor.insertContent('<p></p>');
            }
          });
        },
        icon: 'close',
        tooltip: '\u5220\u9664'
      });
      editor.ui.registry.addButton('insert-new-line', {
        onAction: function () {
          editor.selection.collapse();
          editor.insertContent('<p></p>');
        },
        icon: 'insert-new-line',
        tooltip: '\u63d2\u5165\u6362\u884c'
      });
      editor.ui.registry.addButton('edit', {
        onAction: function (api) {
          if (api.isDisabled()) {
            return;
          }
          var selectionNode = editor.selection.getNode();
          var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(selectionNode);
          if (legacyBlock) {
            if (legacyBlock.id === LegacyCodeBlockId.syntaxHighlighter) {
              syntaxHighlighterDialog.open(editor, settings, legacyCodeBlock$1.parseCodeLanguage(legacyBlock)).then();
            } else if (legacyBlock.id === LegacyCodeBlockId.cnblogsCode) {
              removeContentEditableAttribute(selectionNode);
              editor.focus();
              editor.selection.select(legacyBlock.targetElement.firstChild);
              editor.selection.collapse(true);
            }
          } else {
            Dialog.open(editor, settings, getSelectedLanguage(editor)).then(function () {
              return void 0;
            });
          }
        },
        icon: 'edit-block',
        tooltip: '\u7f16\u8f91'
      });
      editor.ui.registry.addContextToolbar('cnb-code-sample', {
        predicate: function (el) {
          if (isCnbCodeSample(el)) {
            if (editor.selection.isCollapsed())
              editor.selection.select(el);
            return true;
          }
          var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(el);
          var selectionNode = editor.selection.getNode();
          return !!legacyBlock && (legacyBlock.id === LegacyCodeBlockId.syntaxHighlighter || legacyBlock.id === LegacyCodeBlockId.cnblogsCode && isDivElement(selectionNode));
        },
        position: 'node',
        scope: 'node',
        items: 'edit delete-code-block insert-new-line'
      });
    };
    var setup$1 = function (editor, settings) {
      registerIcon(editor);
      registerContextToolbar(editor, settings);
      editor.ui.registry.addToggleButton('cnb-code-sample', {
        icon: 'cnb-code-sample',
        tooltip: '\u63d2\u5165\u4ee3\u7801',
        onAction: function () {
          Dialog.open(editor, settings, getSelectedLanguage(editor)).then(function () {
            return void 0;
          });
        },
        onSetup: function (api) {
          var nodeChangeHandler = function () {
            api.setActive(isCnbCodeSample(editor.selection.getNode()) || !!legacyCodeBlock$1.isLegacyCodeBlock(editor.selection.getNode()));
          };
          editor.on('NodeChange', nodeChangeHandler);
          return function () {
            return editor.off('NodeChange', nodeChangeHandler);
          };
        }
      });
    };

    var register = function (editor, settings) {
      editor.on('init', function () {
        return __awaiter(void 0, void 0, void 0, function () {
          return __generator(this, function (_a) {
            switch (_a.label) {
            case 0:
              legacyCodeBlock$1.markUnEditable(editor);
              return [
                4,
                Promise.all(Array.from(editor.contentDocument.querySelectorAll('pre')).map(function (el) {
                  return __awaiter(void 0, void 0, void 0, function () {
                    var parentElement;
                    return __generator(this, function (_a) {
                      switch (_a.label) {
                      case 0:
                        parentElement = el.parentElement;
                        if (isDetailsElement(parentElement)) {
                          markContentUnEditable(parentElement);
                        }
                        if (!!legacyCodeBlock$1.isLegacyCodeBlock(el))
                          return [
                            3,
                            2
                          ];
                        if (hasNoUnEditableAttribute(el))
                          markContentUnEditable(el);
                        return [
                          4,
                          settings.highlightCodeBlock(el, editor)
                        ];
                      case 1:
                        _a.sent();
                        _a.label = 2;
                      case 2:
                        return [2];
                      }
                    });
                  });
                }))
              ];
            case 1:
              _a.sent();
              return [2];
            }
          });
        });
      });
      editor.on('dblclick', function (event) {
        var targetEl = event.target;
        if (isCnbCodeSample(targetEl)) {
          var el = editor.selection.getNode();
          Dialog.initFoldCodeOptions(el);
          Dialog.open(editor, initPluginSettings(editor), getSelectedLanguage(editor)).then();
        }
        var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(editor.selection.getNode());
        if (legacyBlock) {
          switch (legacyBlock.id) {
          case legacyCodeBlock$1.LegacyCodeBlockId.syntaxHighlighter:
            syntaxHighlighterDialog.open(editor, initPluginSettings(editor), legacyCodeBlock$1.parseCodeLanguage(legacyBlock)).then();
            break;
          }
        }
      });
      editor.on('click', function (event) {
        var target = event.target;
        var legacyBlock = legacyCodeBlock$1.isLegacyCodeBlock(target);
        var selectedEl;
        if (legacyBlock && legacyBlock.id === legacyCodeBlock$1.LegacyCodeBlockId.cnblogsCode) {
          selectedEl = legacyBlock.containerElement;
          if (isPreElement(target) || isDivElement(target)) {
            var cnblogsCodeContainer = isDivElement(target) ? target : target.parentElement;
            if (cnblogsCodeContainer) {
              markContentUnEditable(cnblogsCodeContainer);
              editor.selection.select(cnblogsCodeContainer);
            }
          } else {
            removeContentEditableAttribute(legacyBlock.containerElement);
            addSelectedAttribute(selectedEl);
          }
        }
        editor.$(legacyCodeBlock$1.selector.selectedCnblogsCode).filter(function (idx, el) {
          return el !== selectedEl;
        }).removeAttr('data-mce-selected');
      });
      editor.on('input', function () {
        var timerId = setTimeout(function () {
          legacyCodeBlock$1.appendWhiteSpaceForInlineCnblogsCode(editor);
          clearTimeout(timerId);
        }, 1);
      });
    };

    var style$1 = '/*#region shCoreDefault*/\n.syntaxhighlighter a,\n.syntaxhighlighter div,\n.syntaxhighlighter code,\n.syntaxhighlighter table,\n.syntaxhighlighter table td,\n.syntaxhighlighter table tr,\n.syntaxhighlighter table tbody,\n.syntaxhighlighter table thead,\n.syntaxhighlighter table caption,\n.syntaxhighlighter textarea,\npre[class*="brush:"][class*="language-"],\npre[class*="brush:"] {\n    -moz-border-radius: 0 0 0 0 !important;\n    -webkit-border-radius: 0 0 0 0 !important;\n    background: none !important;\n    border: 0 !important;\n    bottom: auto !important;\n    float: none !important;\n    height: auto !important;\n    left: auto !important;\n    line-height: 1.1em !important;\n    margin: 0 !important;\n    outline: 0 !important;\n    overflow: visible !important;\n    padding: 0 !important;\n    position: static !important;\n    right: auto !important;\n    text-align: left !important;\n    top: auto !important;\n    vertical-align: baseline !important;\n    width: auto !important;\n    box-sizing: content-box !important;\n    font-family: "Consolas", "Bitstream Vera Sans Mono", "Courier New", Courier, monospace !important;\n    font-weight: normal !important;\n    font-style: normal !important;\n    font-size: 1em !important;\n    min-height: inherit !important;\n    min-height: auto !important;\n}\npre[class*="brush:"][class*="language-"],\npre[class*="brush:"] {\n    color: inherit;\n    font-size: 12px !important;\n    line-height: 1.8em !important;\n}\npre[class*="brush:"][class*="language-"] > code {\n    white-space: pre-wrap;\n}\npre[class*="gutter:true"] {\n    padding-left: 35px;\n}\n.syntaxhighlighter {\n    width: 100% !important;\n    margin: 1em 0 1em 0 !important;\n    position: relative !important;\n    overflow: auto !important;\n    font-size: 1em !important;\n}\n.syntaxhighlighter.source {\n    overflow: hidden !important;\n}\n.syntaxhighlighter .bold {\n    font-weight: bold !important;\n}\n.syntaxhighlighter .italic {\n    font-style: italic !important;\n}\n.syntaxhighlighter .line {\n    white-space: pre !important;\n}\n.syntaxhighlighter table {\n    width: 100% !important;\n}\n.syntaxhighlighter table caption {\n    text-align: left !important;\n    padding: .5em 0 .5em 1em !important;\n}\n.syntaxhighlighter table td.code {\n    width: 100% !important;\n}\n.syntaxhighlighter table td.code .container {\n    position: relative !important;\n    z-index: 1;\n}\n.syntaxhighlighter table td.code .container textarea {\n    box-sizing: border-box !important;\n    position: absolute !important;\n    left: 0 !important;\n    top: 0 !important;\n    width: 100% !important;\n    height: 100% !important;\n    border: none !important;\n    background: #fff !important;\n    padding-left: 1em !important;\n    overflow: hidden !important;\n    white-space: pre !important;\n}\n.syntaxhighlighter table td.gutter .line {\n    text-align: right !important;\n    padding: 0 .5em 0 1em !important;\n}\n.syntaxhighlighter table td.code .line {\n    padding: 0 1em !important;\n}\n.syntaxhighlighter.nogutter td.code .container textarea, .syntaxhighlighter.nogutter td.code .line {\n    padding-left: 0 !important;\n}\n\n.syntaxhighlighter.show {\n    display: block !important;\n}\n\n.syntaxhighlighter.collapsed table {\n    display: none !important;\n}\n\n.syntaxhighlighter.collapsed .toolbar {\n    padding: .1em .8em 0 .8em !important;\n    font-size: 1em !important;\n    position: static !important;\n    width: auto !important;\n    height: auto !important;\n}\n\n.syntaxhighlighter.collapsed .toolbar span {\n    display: inline !important;\n    margin-right: 1em !important;\n}\n\n.syntaxhighlighter.collapsed .toolbar span a {\n    padding: 0 !important;\n    display: none !important;\n}\n\n.syntaxhighlighter.collapsed .toolbar span a.expandSource {\n    display: inline !important;\n}\n\n.syntaxhighlighter .toolbar {\n    position: absolute !important;\n    right: 1px !important;\n    top: 1px !important;\n    width: 11px !important;\n    height: 11px !important;\n    font-size: 10px !important;\n    z-index: 10 !important;\n}\n\n.syntaxhighlighter .toolbar span.title {\n    display: inline !important;\n}\n\n.syntaxhighlighter .toolbar a {\n    display: block !important;\n    text-align: center !important;\n    text-decoration: none !important;\n    padding-top: 1px !important;\n}\n\n.syntaxhighlighter .toolbar a.expandSource {\n    display: none !important;\n}\n\n.syntaxhighlighter.ie {\n    font-size: .9em !important;\n    padding: 1px 0 1px 0 !important;\n}\n\n.syntaxhighlighter.ie .toolbar {\n    line-height: 8px !important;\n}\n\n.syntaxhighlighter.ie .toolbar a {\n    padding-top: 0 !important;\n}\n\n.syntaxhighlighter.printing .line.alt1 .content, .syntaxhighlighter.printing .line.alt2 .content, .syntaxhighlighter.printing .line.highlighted .number, .syntaxhighlighter.printing .line.highlighted.alt1 .content, .syntaxhighlighter.printing .line.highlighted.alt2 .content {\n    background: none !important;\n}\n\n.syntaxhighlighter.printing .line .number {\n    color: #bbb !important;\n}\n\n.syntaxhighlighter.printing .line .content {\n    color: #000 !important;\n}\n\n.syntaxhighlighter.printing .toolbar {\n    display: none !important;\n}\n\n.syntaxhighlighter.printing a {\n    text-decoration: none !important;\n}\n\n.syntaxhighlighter.printing .plain, .syntaxhighlighter.printing .plain a {\n    color: #000 !important;\n}\n\n.syntaxhighlighter.printing .comments, .syntaxhighlighter.printing .comments a {\n    color: #008200 !important;\n}\n\n.syntaxhighlighter.printing .string, .syntaxhighlighter.printing .string a {\n    color: blue !important;\n}\n\n.syntaxhighlighter.printing .keyword {\n    color: #069 !important;\n    font-weight: bold !important;\n}\n\n.syntaxhighlighter.printing .preprocessor {\n    color: gray !important;\n}\n\n.syntaxhighlighter.printing .variable {\n    color: #a70 !important;\n}\n\n.syntaxhighlighter.printing .value {\n    color: #090 !important;\n}\n\n.syntaxhighlighter.printing .functions {\n    color: #ff1493 !important;\n}\n\n.syntaxhighlighter.printing .constants {\n    color: #06c !important;\n}\n\n.syntaxhighlighter.printing .script {\n    font-weight: bold !important;\n}\n\n.syntaxhighlighter.printing .color1, .syntaxhighlighter.printing .color1 a {\n    color: gray !important;\n}\n\n.syntaxhighlighter.printing .color2, .syntaxhighlighter.printing .color2 a {\n    color: #ff1493 !important;\n}\n\n.syntaxhighlighter.printing .color3, .syntaxhighlighter.printing .color3 a {\n    color: red !important;\n}\n\n.syntaxhighlighter.printing .break, .syntaxhighlighter.printing .break a {\n    color: #000 !important;\n}\n\n.syntaxhighlighter {\n    background-color: #fff !important;\n}\n\n.syntaxhighlighter .line.alt1 {\n    background-color: #fff !important;\n}\n\n/*.syntaxhighlighter .line.alt2 {\n    background-color: #fff !important;\n}*/\n\n.syntaxhighlighter .line.highlighted.alt1, .syntaxhighlighter .line.highlighted.alt2 {\n    background-color: #e0e0e0 !important;\n}\n.syntaxhighlighter .line.highlighted.number {\n    color: #000 !important;\n}\n.syntaxhighlighter table caption {\n    color: #000 !important;\n}\n.syntaxhighlighter .gutter {\n    color: #afafaf !important;\n}\n.syntaxhighlighter .gutter .line {\n    border-right: 3px solid #6ce26c !important;\n}\n.syntaxhighlighter .gutter .line.highlighted {\n    background-color: #6ce26c !important;\n    color: #fff !important;\n}\n.syntaxhighlighter.printing .line .content {\n    border: none !important;\n}\n.syntaxhighlighter.collapsed {\n    overflow: visible !important;\n}\n.syntaxhighlighter.collapsed .toolbar {\n    color: blue !important;\n    background: #fff !important;\n    border: 1px solid #6ce26c !important;\n}\n.syntaxhighlighter.collapsed .toolbar a {\n    color: blue !important;\n}\n.syntaxhighlighter.collapsed .toolbar a:hover {\n    color: red !important;\n}\n.syntaxhighlighter .toolbar {\n    color: #fff !important;\n    background: #6ce26c !important;\n    border: none !important;\n}\n.syntaxhighlighter .toolbar a {\n    color: #fff !important;\n}\n.syntaxhighlighter .toolbar a:hover {\n    color: #000 !important;\n}\n.syntaxhighlighter .plain, .syntaxhighlighter .plain a {\n    color: #000 !important;\n}\n.syntaxhighlighter .comments, .syntaxhighlighter .comments a {\n    color: #008200 !important;\n}\n.syntaxhighlighter .string, .syntaxhighlighter .string a {\n    color: blue !important;\n}\n.syntaxhighlighter .keyword {\n    color: #069 !important;\n}\n.syntaxhighlighter .preprocessor {\n    color: gray !important;\n}\n\n.syntaxhighlighter .variable {\n    color: #a70 !important;\n}\n\n.syntaxhighlighter .value {\n    color: #090 !important;\n}\n\n.syntaxhighlighter .functions {\n    color: #ff1493 !important;\n}\n\n.syntaxhighlighter .constants {\n    color: #06c !important;\n}\n\n.syntaxhighlighter .script {\n    font-weight: bold !important;\n    color: #069 !important;\n    background-color: none !important;\n}\n\n.syntaxhighlighter .color1, .syntaxhighlighter .color1 a {\n    color: gray !important;\n}\n\n.syntaxhighlighter .color2, .syntaxhighlighter .color2 a {\n    color: #ff1493 !important;\n}\n\n.syntaxhighlighter .color3, .syntaxhighlighter .color3 a {\n    color: red !important;\n}\n\n.syntaxhighlighter .keyword {\n    font-weight: bold !important;\n}\n\n.syntaxhighlighter code {\n    white-space: pre-wrap;\n    white-space: -moz-pre-wrap !important;\n    white-space: -pre-wrap;\n    white-space: -o-pre-wrap;\n}\n\n.syntaxhighlighter .line {\n    white-space: normal !important;\n    line-height: 1.8em !important;\n}\n\n.syntaxhighlighter code {\n    line-height: 1.8em !important;\n}\n\n.syntaxhighlighter .toolbar {\n    display: none;\n}\n\n.syntaxhighlighter.collapsed .toolbar {\n    display: block;\n    background: #f5f5f5 !important;\n    border: 1px solid #ccc !important;\n    padding: .5em .8em .5em .8em !important;\n}\n\n.syntaxhighlighter table td.code {\n    width: auto !important;\n}\n.syntaxhighlighter .line.alt2 {\n    background-color: #f4f4f4 !important;\n}\n.syntaxhighlighter .gutter {\n    width: 35px !important;\n}\n.syntaxhighlighter .gutter .line {\n    border-right: 2px solid #6ce26c !important;\n}\n.syntaxhighlighter table td.gutter .line {\n    padding: 0 .5em 0 .5em !important;\n    text-align: right !important;\n}\n.syntaxhighlighter .keyword {\n    font-weight: normal !important;\n    color: #00f !important;\n}\n.syntaxhighlighter a, .syntaxhighlighter div, .syntaxhighlighter code, .syntaxhighlighter table, .syntaxhighlighter table td, .syntaxhighlighter table tr, .syntaxhighlighter table tbody, .syntaxhighlighter table thead, .syntaxhighlighter table caption, .syntaxhighlighter textarea {\n    font-size: 12px !important;\n}';

    var style = '.cnblogs_code[data-mce-selected] { outline: 3px solid #b4d7ff; }\n.cnblogs_code pre { margin-top: 0; margin-bottom: 0; }\n.cnblogs_code { max-width: 100%; overflow-x: auto; margin: 1rem 0; }\ndiv.cnblogs_code { \nbackground-color: #F5F5F5;\nfont-family: Courier New;\nfont-size: 12px; \nborder: 1px solid #CCCCCC;\npadding: 5px;\nword-break: break-all;\noverflow: auto;\nmax-width: 100%;\nmargin: 5px 0px;\n}\n.cnblogs_code_hide { display:none; }\n.code_img_closed {\n    vertical-align: middle;\n    padding-right: 5px;\n}\n.code_img_opened {\n    vertical-align: middle;\n    padding-right: 5px;\n}\n.cnblogs_code_collapse {\n    border-right: #808080 1px solid;\n    border-top: #808080 1px solid;\n    border-left: #808080 1px solid;\n    border-bottom: #808080 1px solid;\n    background-color: #FFF;\n    padding: 2px;\n}\nspan.cnblogs_code, code.cnblogs_code { background-color: rgb(245, 245, 245); font-family: "Courier New"; border: 1px solid rgb(204, 204, 204); overflow: auto; padding: 2px; }';

    var setup = function (editor) {
      return __awaiter(void 0, void 0, void 0, function () {
        var settings;
        return __generator(this, function (_a) {
          editor.contentStyles.push(style$1);
          editor.contentStyles.push(style);
          settings = initPluginSettings(editor);
          setup$2(editor, settings);
          setup$1(editor, settings);
          register(editor, settings);
          return [2];
        });
      });
    };
    function Plugin () {
      tinymce.PluginManager.add('cnb-code-sample', setup);
    }

    Plugin();

})();
